﻿using System;
using System.Data;
using SoftwareWebDidactico.Modelo;
using System.Collections;
using System.Web.UI.WebControls;

namespace SoftwareWebDidactico
{
    public partial class Busqueda : System.Web.UI.Page
    {
        DataClassesDataContext db = new DataClassesDataContext();
        ConsultasBD consultas = new ConsultasBD();

        protected void Page_Load(object sender, EventArgs e)
        {
            string cadena = Request.QueryString["cadena"];
            ArrayList resultadosBusqueda = consultas.resultadosBusquedaDocumentacion(cadena);

            cadenaBuscadaLabel.Text = cadena;
            resultadosLabel.Text = resultadosBusqueda.Count.ToString();

            DataSet ds = new DataSet();
            ds.Tables.Add("docs");
            ds.Tables[0].Columns.Add("url");
            ds.Tables[0].Columns.Add("seccion");
            ds.Tables[0].Columns.Add("titulo");

            char[] sp = { '-' };
            char[] barra = { '/' };

            foreach (ListItem li in resultadosBusqueda)
            {
                DataRow dr = ds.Tables[0].NewRow();

                string[] info = li.Text.ToString().Split(sp);

                switch (info[0])
                {
                    case "Documentación": dr["url"] = "~/Doc.aspx?id=" + li.Value;
                        break;
                    case "Temario": dr["url"] = "~/Tema/Tema.aspx?id=" + li.Value;
                        break;
                    case "Duda de usuario": dr["url"] = "~/EDP/Entrada.aspx?id=" + li.Value;
                        break;
                    case "Cuestión del espacio de preguntas": dr["url"] = "~/EDP/Entrada.aspx?id=" + li.Value;
                        break;
                    case "Entrada F.A.Q": dr["url"] = "~/FAQ/CuestionFAQ.aspx?id=" + li.Value;
                        break;
                    case "Respuesta del espacio de preguntas": dr["url"] = "~/EDP/Entrada.aspx?id=" + li.Value;
                        break;
                    case "Archivo de descarga":
                        string[] enlaces = li.Value.ToString().Split(barra);
                        dr["url"] = "~/Downloads/ListaDescargas.aspx?grupo="+enlaces[0]+"&cat="+enlaces[1];
                        break;
                }
                dr["seccion"] = info[0];
                dr["titulo"] = info[1];
                ds.Tables[0].Rows.Add(dr);
            }

            resultadosDataList.DataSource = ds;
            resultadosDataList.DataBind();

        }



    }
}