﻿using System;
using System.Data;
using System.Linq;
using System.Data.SqlClient;
using System.Configuration;
using System.Web.UI.WebControls;
using SoftwareWebDidactico.Modelo;

namespace SoftwareWebDidactico.Downloads
{
    public partial class ListaDescargas : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            DataClassesDataContext db = new DataClassesDataContext();

            string nombreCategoria = (from categorias in db.CategoriaDescarga
                                      where categorias.idCategoriaDescarga==int.Parse(Request.QueryString["cat"])
                                      select categorias.nombre).First();

            grupoLabel.Text = nombreCategoria;

            int grupo = int.Parse(Request.QueryString["grupo"]);
            int categoria = int.Parse(Request.QueryString["cat"]);

            SqlConnection con = new SqlConnection();
            SqlCommand cmd = new SqlCommand();

            con.ConnectionString = ConfigurationManager.ConnectionStrings["DBSofWebDidConnectionString"].ConnectionString;
            
            con.Open();

            cmd.Connection = con;
            cmd.CommandTimeout = 0;
            string commandText = "SELECT * FROM TbArchivo WHERE grupo=@grupo AND categoria=@categoria";
            cmd.CommandText = commandText;
            cmd.CommandType = CommandType.Text;

            cmd.Parameters.Add("@grupo", SqlDbType.Int);
            cmd.Parameters.Add("@categoria", SqlDbType.Int);

            cmd.Parameters["@grupo"].Value = grupo;
            cmd.Parameters["@categoria"].Value = categoria;

            DataSet ds = new DataSet();
            SqlDataAdapter da = new SqlDataAdapter(cmd);
            da.Fill(ds);

            gvFiles.DataSource = ds;
            gvFiles.DataBind();

            con.Close();
        }
    }
}