﻿using System;
using System.Collections;
using System.Linq;
using System.Data.SqlClient;
using Telerik.Web.UI;
using SoftwareWebDidactico.Modelo;
using System.Configuration;
using System.Web.Security;
using System.Web.Configuration;

namespace SoftwareWebDidactico.EDP
{
    public partial class NuevaRespuestaEspacio : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void añadirEtiquetaRadButton_Click(object sender, EventArgs e)
        {
            etiquetasRadListBox.Items.Add(new Telerik.Web.UI.RadListBoxItem(etiquetaRadComboBox.Text, etiquetaRadComboBox.SelectedValue));
        }

        protected void eliminarEtiquetaRadButton_Click(object sender, EventArgs e)
        {
            if (etiquetasRadListBox.SelectedIndex != -1)
            {
                etiquetasRadListBox.Items.Remove(etiquetasRadListBox.Items[etiquetasRadListBox.SelectedIndex]);
            }

            etiquetasRadListBox.DataBind();
        }

        protected bool existeEtiqueta(string etiqueta)
        {
            DataClassesDataContext db = new DataClassesDataContext();

            var resultado = ((from e in db.EtiquetaFAQ
                              where e.etiqueta == etiqueta
                              select e).ToList()).Count;

            if (resultado > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        protected void crearEntradaRadButton_Click(object sender, EventArgs e)
        {
            ArrayList etiquetas = new ArrayList();
            DataClassesDataContext db = new DataClassesDataContext();

            /* Crear etiquetas */
            for (int indP = 0; indP < etiquetasRadListBox.Items.Count; indP++)
            {
                RadListBoxItem item = (RadListBoxItem)etiquetasRadListBox.Items[indP];

                if (!existeEtiqueta(item.Text))
                {
                    int etiquetaID = db.AñadirEtiquetaFAQ(item.Text);

                    etiquetas.Add(etiquetaID.ToString());
                }
                else
                {
                    etiquetas.Add(item.Value);
                }
            }

            /* Crear la entrada al FAQ */
            int entradaID;

            if (Roles.GetRolesForUser().Count() > 0)
            {
                MembershipUser m = Membership.GetUser();
                Guid key = (Guid)m.ProviderUserKey;
                entradaID = db.AñadirNuevaEntradaEspacio(preguntaRadTextBox.Text, int.Parse(categoriaRadComboBox.SelectedValue), resumenCKEditor.Text, key);
            }

            else
            {
                entradaID = db.AñadirNuevaEntradaEspacio(preguntaRadTextBox.Text, int.Parse(categoriaRadComboBox.SelectedValue), resumenCKEditor.Text, null);
            }
            /* Insertar las etiquetas a la pregunta */
            foreach (string idEtiqueta in etiquetas)
            {
                db.AñadirEntradaEtiqueta(entradaID, int.Parse(idEtiqueta));
            }

            limpiarCampos();


            /* Redirigir a la entrada creada */
            Response.Redirect("~/EDP/Entrada.aspx?id="+entradaID.ToString());
        }

        protected void limpiarCampos()
        {
            preguntaRadTextBox.Text = "";
            resumenCKEditor.Text = "";
            etiquetasRadListBox.Items.Clear();
            etiquetaRadComboBox.Text = "";
        }
    }
}