﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Web.UI.WebControls;

namespace SoftwareWebDidactico
{
    public partial class SinRespuesta : System.Web.UI.Page
    {
        SqlConnection con = new SqlConnection();
        ConsultasBD consultas = new ConsultasBD();
        string strPaginacion = string.Empty;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                cargarPreguntas();
            }
        }

        #region Cargar preguntas

        private void cargarPreguntas()
        {
            SqlConnection con = new SqlConnection();
            SqlCommand cmd = new SqlCommand();

            con.ConnectionString = ConfigurationManager.ConnectionStrings["DBSofWebDidConnectionString"].ConnectionString;

            cmd.CommandType = CommandType.StoredProcedure;
            cmd.CommandText = "SeleccionTemasEspacioSinRespuesta";
            cmd.Connection = con;

            DataSet ds = new DataSet();
            SqlDataAdapter da = new SqlDataAdapter(cmd);
            da.Fill(ds);

            PagedDataSource objPds = new PagedDataSource();

            objPds.DataSource = ds.Tables[0].DefaultView;
            objPds.AllowPaging = true;
            objPds.PageSize = 6;

            int CurPage;

            if (Request.QueryString["IDP"] != null)
                CurPage = Convert.ToInt32(Request.QueryString["IDP"]);
            else
                CurPage = 1;

            objPds.CurrentPageIndex = CurPage - 1;
            strPaginacion = "";

            if (!objPds.IsFirstPage)
                strPaginacion = "<a href='SinRespuesta.aspx?IDP=" + Convert.ToString(CurPage - 1) + "' class=link11px_blu>&lt;&lt; Anterior</a>";

            if (objPds.PageCount > 0)
                strPaginacion += "<span class='txt11px_Neg'> (Página " + CurPage.ToString() + " de " + objPds.PageCount.ToString() + ")</span> ";

            if (objPds.PageCount > 1)
                if (!objPds.IsLastPage)
                    strPaginacion += "<a href='SinRespuesta.aspx?IDP=" + Convert.ToString(CurPage + 1) + "' class=link11px_blu>Siguiente &gt;&gt;</a>";

            entradasEDPDataList.DataSource = objPds;
            entradasEDPDataList.DataKeyField = "pregunta";
            entradasEDPDataList.DataBind();


        }

        protected string GetPaginacion()
        {
            return (strPaginacion);
        }

        #endregion

        protected void entradaLinkButton_Click(object sender, EventArgs e)
        {
            LinkButton lb = (LinkButton)sender;

            int idPregunta = int.Parse(lb.OnClientClick);

            Response.Redirect("~/EDP/Entrada.aspx?id=" + idPregunta);
        }

    }
}