﻿using System;
using System.Collections;
using System.Data;
using System.Linq;
using System.Data.SqlClient;
using System.Configuration;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.Collections.Generic;
using SoftwareWebDidactico.Modelo;

namespace SoftwareWebDidactico
{
    public partial class TemasEtiquetaEspacio : System.Web.UI.Page
    {
        SqlConnection con = new SqlConnection();
        ConsultasBD consultas = new ConsultasBD();
        string strPaginacion = string.Empty;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                cargarPreguntas();

                filtroEtiquetaLabel.Text = filtroEtiquetaLabel.Text + etiqueta(int.Parse(Request.QueryString["id"]));
            }
        }

        #region Cargar preguntas

        private void cargarPreguntas()
        {
            SqlConnection con = new SqlConnection();
            SqlCommand cmd = new SqlCommand();

            con.ConnectionString = ConfigurationManager.ConnectionStrings["DBSofWebDidConnectionString"].ConnectionString;

            cmd.CommandType = CommandType.StoredProcedure;
            cmd.CommandText = "SeleccionTemasEspacioPorEtiqueta";
            cmd.Connection = con;

            SqlParameter[] param = new SqlParameter[1];
            param[0] = new SqlParameter("@etiqueta", SqlDbType.Int, 16);
            param[0].Value = Request.QueryString["id"];
            cmd.Parameters.AddRange(param);

            DataSet ds = new DataSet();
            SqlDataAdapter da = new SqlDataAdapter(cmd);
            da.Fill(ds);

            PagedDataSource objPds = new PagedDataSource();

            objPds.DataSource = ds.Tables[0].DefaultView;
            objPds.AllowPaging = true;
            objPds.PageSize = 6;

            int CurPage;

            if (Request.QueryString["IDP"] != null)
                CurPage = Convert.ToInt32(Request.QueryString["IDP"]);
            else
                CurPage = 1;

            objPds.CurrentPageIndex = CurPage - 1;
            strPaginacion = "";

            if (!objPds.IsFirstPage)
                strPaginacion = "<a href='TemasEtiquetaEspacio.aspx?id=" + Context.Request["id"] + "&IDP=" + Convert.ToString(CurPage - 1) + "' class=link11px_blu>&lt;&lt; Anterior</a>";

            if (objPds.PageCount > 0)
                strPaginacion += "<span class='txt11px_Neg'> (Página " + CurPage.ToString() + " de " + objPds.PageCount.ToString() + ")</span> ";

            if (objPds.PageCount > 1)
                if (!objPds.IsLastPage)
                    strPaginacion += "<a href='TemasEtiquetaEspacio.aspx?id=" + Context.Request["id"] + "&IDP=" + Convert.ToString(CurPage + 1) + "' class=link11px_blu>Siguiente &gt;&gt;</a>";

            entradasEspacioDataList.DataSource = objPds;
            entradasEspacioDataList.DataKeyField = "pregunta";
            entradasEspacioDataList.DataBind();


        }

        protected string GetPaginacion()
        {
            return (strPaginacion);
        }

        #endregion

        protected void entradaLinkButton_Click(object sender, EventArgs e)
        {
            LinkButton lb = (LinkButton)sender;

            int idPregunta = int.Parse(lb.OnClientClick);

            Response.Redirect("~/EDP/Entrada.aspx?id=" + idPregunta);
        }

        protected string etiqueta(int id)
        {
            DataClassesDataContext db = new DataClassesDataContext();

            return (from e in db.EtiquetaFAQ
                    where e.idEtiqueta == id
                    select e.etiqueta).First<string>();
        }
    }
}