﻿using System;
using System.Data;
using System.Linq;
using System.Data.SqlClient;
using System.Configuration;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.Collections.Generic;
using System.Drawing;
using SoftwareWebDidactico.Modelo;
using System.Web.Security;
using System.Web.Configuration;

namespace SoftwareWebDidactico
{
    public partial class Site : System.Web.UI.MasterPage
    {
        List<RadTreeNode> items = new List<RadTreeNode>();
        ConsultasBD consultas = new ConsultasBD();
        DataClassesDataContext db = new DataClassesDataContext();

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                cargarDocumentacionMenu();
                cargarTemas();
            }

            #region Expandir nodo seleccionado

            if (Session["value"] !=null)
            {
                bool expandido = false;
                foreach (DataListItem dli in temasDataList.Items)
                {
                    if (!expandido)
                    {
                        RadTreeView arbol = (RadTreeView)dli.FindControl("temasRadTreeView");
                        String valor = Session["value"].ToString();
                        RadTreeNode node = arbol.FindNodeByValue(valor);
                        if (node != null)
                        {
                            node.Expanded = true;
                            expandido = true;

                            /* Comprobar si tiene nodos padres */
                            while ((node.Parent != null) &&
                                    node.Parent.GetType().ToString().Equals("Telerik.Web.UI.RadTreeNode")
                                    )
                            {
                                RadTreeNode padre = (RadTreeNode)node.Parent;
                                padre.Expanded = true;
                                node = padre;
                            }
                            
                        }
                    }
                }
            }

            #endregion
 
            #region Comprobar autenticación

            //Roles del usuario logueado
            String[] roles = System.Web.Security.Roles.GetRolesForUser();

            if (roles.Count() > 0)
            {
                var funcionesRol = (from f in db.FuncionesRol
                                    join r in db.aspnet_Roles
                                       on f.idRol equals r.RoleId
                                    where r.RoleName == roles[0].ToString()
                                    select f.funcion).ToList();

                if (funcionesRol.Contains(1))
                {
                    RadMenu.Items[6].Visible = true;
                    RadMenu.Items[6].Items[0].Visible = true;
                }
                if (funcionesRol.Contains(2))
                {
                    RadMenu.Items[6].Visible = true;
                    RadMenu.Items[6].Items[1].Visible = true;
                }
                if (funcionesRol.Contains(3))
                {
                    RadMenu.Items[6].Visible = true;
                    RadMenu.Items[6].Items[2].Visible = true;
                }
                if (funcionesRol.Contains(4))
                {
                    RadMenu.Items[6].Visible = true;
                    RadMenu.Items[6].Items[3].Visible = true;
                }
                if (funcionesRol.Contains(5))
                {
                    RadMenu.Items[6].Visible = true;
                    RadMenu.Items[6].Items[4].Visible = true;
                }
                if (funcionesRol.Contains(6))
                {
                    RadMenu.Items[6].Visible = true;
                    RadMenu.Items[6].Items[5].Visible = true;
                }
                if (funcionesRol.Contains(7))
                {
                    RadMenu.Items[6].Visible = true;
                    RadMenu.Items[6].Items[6].Visible = true;
                }
                if (funcionesRol.Contains(8))
                {
                    RadMenu.Items[6].Visible = true;
                    RadMenu.Items[6].Items[7].Visible = true;
                }
                if (funcionesRol.Contains(9))
                {
                    RadMenu.Items[6].Visible = true;
                    RadMenu.Items[6].Items[8].Visible = true;
                }
                if (funcionesRol.Contains(10))
                {
                    RadMenu.Items[6].Visible = true;
                    RadMenu.Items[6].Items[9].Visible = true;
                }

            #endregion

            }
        }

        protected void logoHeaderImageButton_Click(object sender, System.Web.UI.ImageClickEventArgs e)
        {
            Response.Redirect("~/Inicio.aspx");
        }

        #region Menú principal

        protected void RadMenu_ItemClick(object sender, Telerik.Web.UI.RadMenuEventArgs e)
        {
            if (e.Item.Text == "Inicio")
            {
                Response.Redirect("~/Inicio.aspx");
            }
            /*else if (e.Item.Text == "Administración")
            {
                Response.Redirect("~/Administración/Administracion.aspx");
            }*/
            else if (e.Item.Text == "Descargas")
            {
                Response.Redirect("~/Downloads/Descargas.aspx");
            }
            else if (e.Item.Text == "F.A.Q")
            {
                Response.Redirect("~/FAQ/FAQ.aspx");
            }
            else if (e.Item.Text == "Espacio de preguntas")
            {
                Response.Redirect("~/EDP/Espacio.aspx");
            }
            else if (e.Item.Text == "Revisar resultados")
            {
                if (Roles.IsUserInRole("Administrador") || Roles.IsUserInRole("Usuario"))
                {
                    MembershipUser m = Membership.GetUser();
                    Guid key = (Guid)m.ProviderUserKey;
                    Response.Redirect("~/Test/RegistroTest.aspx?idUsuario=" + key);
                }
            }
            else if (e.Item.Text == "Gestionar categorías")
            {
                Response.Redirect("~/Administración/AdminCategorías/EditarCategorias.aspx");
            }
            else if (e.Item.Text == "Gestionar usuarios")
            {
                Response.Redirect("~/Administración/AdminUsuarios/EditarUsuarios.aspx");
            }
            else if (e.Item.Text == "Gestionar ejercicios de temas")
            {
                Response.Redirect("~/Administración/AdminEjercicios/EditarEjercicios.aspx");
            }
            else if (e.Item.Text == "Gestionar temas")
            {
                Response.Redirect("~/Administración/AdminTemas/EditarTemas.aspx");
            }
            else if (e.Item.Text == "Gestionar documentación")
            {
                Response.Redirect("~/Administración/AdminDocs/EditarDocs.aspx");
            }
            else if (e.Item.Text == "Gestionar F.A.Q")
            {
                Response.Redirect("~/Administración/AdminFaq/EditarFAQ.aspx");
            }
            else if (e.Item.Text == "Gestionar espacio de preguntas")
            {
                Response.Redirect("~/Administración/AdminEspacio/EditarEspacio.aspx");
            }
            else if (e.Item.Text == "Gestionar autoevaluación")
            {
                Response.Redirect("~/Administración/AdminAutoevaluación/EditarAutoevaluacion.aspx");
            }
            else if (e.Item.Text == "Gestionar descargas")
            {
                Response.Redirect("~/Administración/AdminDescargas/EditarDescargas.aspx");
            }
            else if (e.Item.Text == "Gestionar roles")
            {
                Response.Redirect("~/Administración/AdminRoles/EditarRoles.aspx");
            }
            else if (e.Item.Text == "Hacer test")
            {
                Response.Redirect("~/Test/Autoevaluacion.aspx");
            }
            else if (e.Item.Text == "Acerca de...")
            {
                
            }
            else if (e.Item.Text == "Manual de usuario")
            {
                Response.Redirect("~/Manual.aspx");
            }
        }

        protected void cargarDocumentacionMenu()
        {
            var resultado = (from d in db.Documentación
                             orderby d.preferencia ascending
                            select new RadMenuItem
                            {
                                NavigateUrl = "~/Doc.aspx?id=" + d.id,
                                Text = d.titulo
                            }).ToList();

            for (int i = 0; i < resultado.Count; i++)
            {
                RadMenu.Items[1].Items.Add((RadMenuItem)resultado[i]);
            }
        }

        protected void busquedaRadTextBox_TextChanged(object sender, EventArgs e)
        {
            Response.Redirect("~/Busqueda.aspx?cadena=" + busquedaRadTextBox.Text);
        }

        #endregion

        #region Buscar

        protected void btnSearch_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/Busqueda.aspx?search=" + busquedaRadTextBox.Text);
        }

        #endregion

        #region Temas

        protected bool lineaAprendizajeUnicaTema(int idCategoria)
        {
            string resultado = (from ct in db.CategoriaTema
                                where ct.idCategoria == idCategoria
                                select ct.linea).First<string>();

            if (resultado.ToString() == "unica")
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        protected void cargarTemas()
        {
            int idArbol = 0;
            foreach (DataListItem dli in temasDataList.Items)
            {
                Label idCategoria = (Label)dli.FindControl("idCategoriaLabel");
                RadTreeView arbol = (RadTreeView)dli.FindControl("temasRadTreeView");
                idArbol++;

                int idCateg = int.Parse(idCategoria.Text);

                DataSet ds = temasDataSet(idCateg);

                DataRelation relation = new DataRelation("NodeRelation",
                        ds.Tables[0].Columns["idTema"],
                        ds.Tables[0].Columns["referenciaPadre"],
                        false);
                relation.Nested = true;

                if (lineaAprendizajeUnicaTema(idCateg))
                {
                    ds.Relations.Add(relation);

                    foreach (DataRow dbRow in ds.Tables[0].Rows)
                    {
                        RadTreeNode node = new RadTreeNode();
                        node.ForeColor = Color.White;

                        if (dbRow["referenciaPadre"].ToString() == "")
                        {
                            node.Value = dbRow["idTema"].ToString();
                            node.Text = dbRow["titulo"].ToString();
                            //node.NavigateUrl = "~/Tema/Tema.aspx?id=" + dbRow["idTema"];
                            arbol.Nodes.Add(node);

                            RecursivelyPopulate(dbRow, node);
                        }
                    }
                }
                else 
                {
                    ds.Relations.Add(relation);

                    RadTreeNode intro = new RadTreeNode("Línea de introducción");
                    intro.Value = "intro" + idArbol;
                    arbol.Nodes.Add(intro);

                    RadTreeNode compl = new RadTreeNode("Línea completa");
                    compl.Value = "compl" + idArbol;
                    arbol.Nodes.Add(compl);

                    foreach (DataRow dbRow in ds.Tables[0].Rows)
                    {
                        RadTreeNode node = new RadTreeNode();
                        node.ForeColor = Color.White;

                        if (dbRow["referenciaPadre"].ToString() == "")
                        {
                            node.Value = dbRow["idTema"].ToString();
                            node.Text = dbRow["titulo"].ToString();
                            //node.NavigateUrl = "~/Tema/Tema.aspx?id=" + dbRow["idTema"];

                            if (dbRow["linea"].ToString().Equals("introduccion"))
                            {
                                arbol.Nodes[0].Nodes.Add(node);
                            }
                            else if (dbRow["linea"].ToString().Equals("completa"))
                            {
                                arbol.Nodes[1].Nodes.Add(node);
                            }
                            else /* El tema está en introducción y completa */
                            {
                                arbol.Nodes[0].Nodes.Add(node);

                                RadTreeNode node2 = new RadTreeNode();
                                node2 = node.Clone();

                                arbol.Nodes[1].Nodes.Add(node2);

                                RecursivelyPopulate(dbRow, node2);
                            }

                            RecursivelyPopulate(dbRow, node);
                        }
                    }
                }
            }
        }

        protected void arbol_NodeClick(object sender, RadTreeNodeEventArgs e)
        {
            foreach (DataListItem dli in temasDataList.Items)
            {
                RadTreeView arbol = (RadTreeView)dli.FindControl("temasRadTreeView");
                if ((arbol.SelectedNode != null) && (arbol.SelectedNode.Text != "Línea de introducción")
                     && (arbol.SelectedNode.Text != "Línea completa") && (arbol.SelectedNode.Parent.GetType().ToString() != "Telerik.Web.UI.RadTreeView"))
                {
                    RadTreeNode node = (RadTreeNode)arbol.SelectedNode.Parent;
                    Session["value"] = node.Value;

                    Response.Redirect("~/Tema/Tema.aspx?id=" + e.Node.Value);  
                }
                else if ((arbol.SelectedNode != null)  && (arbol.SelectedNode.Text != "Línea de introducción")
                     && (arbol.SelectedNode.Text != "Línea completa") && (arbol.SelectedNode.Parent.GetType().ToString() == "Telerik.Web.UI.RadTreeView"))
                {
                    RadTreeNode node = (RadTreeNode)arbol.SelectedNode;
                    Session["value"] = node.Value;

                    Response.Redirect("~/Tema/Tema.aspx?id=" + e.Node.Value); 
                }
            }

                   
        }

        protected DataSet temasDataSet(int idCategoria)
        {
            SqlConnection con = new SqlConnection();
            SqlCommand cmd = new SqlCommand();

            con.ConnectionString = ConfigurationManager.ConnectionStrings["DBSofWebDidConnectionString"].ConnectionString;

            SqlParameter[] param = new SqlParameter[1];
            param[0] = new SqlParameter("@categoria", SqlDbType.Int, 16);
            param[0].Value = idCategoria;

            cmd.CommandType = CommandType.StoredProcedure;
            cmd.CommandText = "SeleccionInformacionTemas";
            cmd.Connection = con;
            cmd.Parameters.AddRange(param);

            DataSet ds = new DataSet();
            SqlDataAdapter da = new SqlDataAdapter(cmd);
            da.Fill(ds);

            return ds;
        }

        private void RecursivelyPopulate(DataRow dbRow, RadTreeNode node)
        {
            foreach (DataRow childRow in dbRow.GetChildRows("NodeRelation"))
            {
                RadTreeNode childNode = new RadTreeNode(childRow["titulo"].ToString());
                childNode.Value = childRow["idTema"].ToString();

                node.Nodes.Add(childNode);

                RecursivelyPopulate(childRow, childNode);
            }
        }

        #endregion

        #region Login

        protected void salirRadButton_Click(object sender, EventArgs e)
        {
            Session["UserAuthentication"] = "";

            RadMenu.Items[6].Visible = false;

            Panel loginPanel = null;
            Panel datosPanel = null;
            Label userLabel = null;

            foreach (RadMenuItem rmi in RadMenu.Items[1].Items)
            {
                loginPanel = (Panel)rmi.FindControl("loginPanel");
                datosPanel = (Panel)rmi.FindControl("datosPanel");
                userLabel = (Label)rmi.FindControl("userLabel");
            }

            loginPanel.Visible = true;
            datosPanel.Visible = false;
            userLabel.Text = "";
        }

        protected void registroRadButton_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/Registro.aspx");
        }

        #endregion

    }
}