﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using SoftwareWebDidactico.Modelo;

namespace SoftwareWebDidactico
{
    public partial class PlantillaTema : System.Web.UI.MasterPage
    {
        DataClassesDataContext db = new DataClassesDataContext();

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                tituloLabel.Text = (from t in db.TemaC
                                    where t.idTema == int.Parse(Context.Request["id"])
                                    select t.titulo).First<string>().ToUpper();

                var test = (from t in db.Test
                            where t.tema == int.Parse(Context.Request["id"]) && t.visible.Equals(true)
                            select new MenuItem { Text = "Test " + t.idTest, Value = t.idTest.ToString() }).ToList();

                foreach (MenuItem idTest in test)
                {
                    temaMenu.Items[1].ChildItems.Add(idTest);
                }
            }
        }

        protected void temaMenu_MenuItemClick(object sender, MenuEventArgs e)
        {
            Menu menu = (Menu)sender;

            if (e.Item.Text == "Ejercicios")
            {
                Response.Redirect("~/Tema/Ejercicios.aspx?id=" + Context.Request["id"]);
            }
            else if (menu.SelectedItem.Parent != null)
            {
                int idTest = int.Parse(e.Item.Value);
                string tema = (from t in db.Test
                               where t.idTest.Equals(idTest)
                               join d in db.TemaC
                               on t.tema equals d.idTema
                               select d.titulo).First<string>();

                Response.Redirect("~/Test/Test.aspx?tema=" + tema + "&idTest=" + idTest);
            }
        }

    }
}