﻿using System;
using System.Web.UI.WebControls;
using SoftwareWebDidactico.Modelo;
using System.Web.Security;

namespace SoftwareWebDidactico
{
    public partial class Test : System.Web.UI.Page
    {
        ConsultasBD consultas = new ConsultasBD();
        DataClassesDataContext db = new DataClassesDataContext();

        protected void Page_Load(object sender, EventArgs e)
        {
            testLabel.Text = "Test de " + Context.Request["tema"].ToUpper() + " (" + consultas.preguntasTest(int.Parse(Context.Request["idTest"])).ToString() + " preguntas)";
        }

        protected void corregirRadButton_Click(object sender, EventArgs e)
        {
            if (corregirRadButton.Text == "Corregir")
            {
                resultadoPanel.Visible = true;
                corregirRadButton.Text = "Repetir test";

                Decimal preguntasTotales = 0;
                Decimal preguntasCorrectas = 0;

                foreach (DataListItem dli in testDataList.Items)
                {
                    preguntasTotales++;
                    RadioButtonList rbl = (RadioButtonList)dli.FindControl("opcionesRadioButtonList");

                    if (rbl.SelectedValue.ToString() == "verdadera")
                    {
                        preguntasCorrectas++;
                    }
                }

                Decimal porcentaje = (preguntasCorrectas / preguntasTotales) * 100;
                porcentajeLabel.Text = Decimal.Round(porcentaje, 2).ToString() + "%";
                preguntasTotalesLabel.Text = preguntasTotales.ToString();
                preguntasCorrectasLabel.Text = preguntasCorrectas.ToString();

                //Crear registro del test
                if (Roles.IsUserInRole("Administrador") || Roles.IsUserInRole("Usuario"))
                {
                    MembershipUser m = Membership.GetUser(User.Identity.Name);
                    Guid key = (Guid)m.ProviderUserKey;

                    db.AñadirRegistroTestUsuario(int.Parse(Context.Request["idTest"]), key , Decimal.Round(porcentaje, 2));
                }
            }
            else
            {
                resultadoPanel.Visible = false;
                corregirRadButton.Text = "Corregir";

                foreach (DataListItem dli in testDataList.Items)
                {
                    RadioButtonList rbl = (RadioButtonList)dli.FindControl("opcionesRadioButtonList");
                    foreach (ListItem li in rbl.Items)
                    {
                        li.Selected = false;
                    }
                }
            }
        }

    }
}