﻿using System;
using System.Configuration;
using System.Data.SqlClient;
using System.Data;

namespace SoftwareWebDidactico.Utilities
{
    public class FileUtilities
    {
        // Get the list of the files in the database
        public static DataTable GetFileList(int grupo, int categoria)
        {
            DataTable fileList = new DataTable();

            SqlConnection connection = new SqlConnection();
            SqlCommand cmd = new SqlCommand();

            connection.ConnectionString = ConfigurationManager.ConnectionStrings["DBSofWebDidConnectionString"].ConnectionString;
            connection.Open();
            cmd.Connection = connection;
            cmd.CommandTimeout = 0;

            cmd.CommandText = "SELECT idArchivo, nombreArchivo, ContentType, Size, descripcion FROM TbArchivo WHERE grupo=@grupo AND categoria=@categoria";
            cmd.CommandType = CommandType.Text;
            SqlDataAdapter adapter = new SqlDataAdapter();

            cmd.Parameters.Add("@grupo", SqlDbType.Int);
            cmd.Parameters["@grupo"].Value = grupo;

            cmd.Parameters.Add("@categoria", SqlDbType.Int);
            cmd.Parameters["@categoria"].Value = categoria;

            adapter.SelectCommand = cmd;
            adapter.Fill(fileList);

            connection.Close();
            

            return fileList;
        }

        // Save a file into the database
        public static void SaveFile(string name, string contentType,
            int size, byte[] data, int grupo, int categoria, string descripcion)
        {
            SqlConnection connection = new SqlConnection();
            SqlCommand cmd = new SqlCommand();

            connection.ConnectionString = ConfigurationManager.ConnectionStrings["DBSofWebDidConnectionString"].ConnectionString;
            connection.Open();
            cmd.Connection = connection;
            cmd.CommandTimeout = 0;

            string commandText = "INSERT INTO TbArchivo VALUES(@categoria, @nombreArchivo, @ContentType, ";
            commandText = commandText + "@Size, @Data, @grupo, @descripcion)";
            cmd.CommandText = commandText;
            cmd.CommandType = CommandType.Text;

            cmd.Parameters.Add("@nombreArchivo", SqlDbType.NVarChar, 100);
            cmd.Parameters.Add("@ContentType", SqlDbType.VarChar, 50);
            cmd.Parameters.Add("@Size", SqlDbType.Int);
            cmd.Parameters.Add("@Data", SqlDbType.VarBinary);
            cmd.Parameters.Add("@grupo", SqlDbType.Int);
            cmd.Parameters.Add("@categoria", SqlDbType.Int);
            cmd.Parameters.Add("@descripcion", SqlDbType.Text);

            cmd.Parameters["@nombreArchivo"].Value = name;
            cmd.Parameters["@ContentType"].Value = contentType;
            cmd.Parameters["@Size"].Value = size;
            cmd.Parameters["@Data"].Value = data;
            cmd.Parameters["@grupo"].Value = grupo;
            cmd.Parameters["@categoria"].Value = categoria;
            cmd.Parameters["@descripcion"].Value = descripcion;

            try
            {
                cmd.ExecuteNonQuery();
            }
            catch (SqlException ex)
            {

            }

            connection.Close();
        }

        // Get a file from the database by ID
        public static DataTable GetAFile(int id)
        {
            DataTable file = new DataTable();
            SqlConnection connection = new SqlConnection();
            SqlCommand cmd = new SqlCommand();

            connection.ConnectionString = ConfigurationManager.ConnectionStrings["DBSofWebDidConnectionString"].ConnectionString;
            connection.Open();
            cmd.Connection = connection;
            cmd.CommandTimeout = 0;

            cmd.CommandText = "SELECT idArchivo, nombreArchivo, ContentType, Size, Data FROM TbArchivo "
                + "WHERE idArchivo=@ID";
            cmd.CommandType = CommandType.Text;
            SqlDataAdapter adapter = new SqlDataAdapter();

            cmd.Parameters.Add("@ID", SqlDbType.Int);
            cmd.Parameters["@ID"].Value = id;

            adapter.SelectCommand = cmd;
            adapter.Fill(file);

            connection.Close();

            return file;
        }
    }
}